//#define E4
//#define T440bx
#define E40

#include <windows.h>
#include "winceKBhook.h"
#include "Simpleini.h"
#include <Commctrl.h>
#include <time.h>

//#include <cegl.h>

#define DisplayLogoID 1001
#define AboutButtonID 1002
#define NoAutoNUCID   1003
#define SuperresID    1004
#define JPEGqualityID 1005
#define FocusStackID  1006
#define MSXbuttonID	  1007
#define ZoomButtonID  1008

HINSTANCE g_hInst = NULL;     // Handle to the application instance
HWND g_hwndMain = NULL;       // Handle to the application main window
HWND hwin = NULL;
HWND NextControl, g_hwndDisplayLogo, g_hwndAboutButton, g_hwndNoAutoNUC, g_hwndMakeSupreres, g_hwndSetJPEGquality, g_hwndCaptureStack,
g_hwndLeftRightLabel, g_hwndMSX, g_hwndHackURL, g_hwndZoom = NULL;

HWINEVENTHOOK hEvent = NULL;
HANDLE hFocusThread = NULL;
DWORD dwOldTime = 0;
SYSTEMTIME st;
CSimpleIniA ini;
bool InWindow = false, MakeSuperres = false, MakeStack = false;

bool SelectedMSX = false;
bool SelectedZoom = false;
char zoomset[128];

int JoyButton, BackButton, JoyDown, JoyUp, JoyLeft, JoyRight, PowerButton;


#ifdef E4
			float MSXLevel = 1;
#else if T440bx
			float MSXLevel = 2.1827736;
#endif

float ZoomLevel = 1;

char StoragePath[128] = "\\StorageCard\\DCIM\\ImageSequences\\";

HWND g_hwndTimedOwner;
BOOL g_bTimedOut;

TCHAR strClass[99], strWintext[99];

TCHAR g_szTitle[80] = TEXT ("Spirit's hack menu"),    
                              // Application main window name
      g_szClassName[80] = TEXT ("HackClass");  
                              // Main window class name

//CCEDraw m_ceDraw;

#if defined(E40) || defined(E4)
#define INIPATH "FlashBFS/system/hack.ini"
#endif
#if defined(T440bx)
#define INIPATH "FlashFS/system/hack.ini"
#endif

void SetRegistry(const char * key, const char * value)
{
	char output[256];
	
	sprintf(output, "%s %s", key, value);
	wchar_t keyBuff[4096];
	mbstowcs( keyBuff, output, strlen(output)+1);

	PROCESS_INFORMATION pi;

	if(CreateProcess(L"rset.exe",
		keyBuff, NULL, NULL, FALSE, 0,
			NULL, NULL, NULL, &pi) == 0)
		printf("Cannot start rset.exe for changing settings.\n");
	else
	{
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}
	//printf("_______Setting %s to %s\n", key, value);
}



void SetDisplay(bool enable)
{
	SetRegistry("ui.userSettings.hideGraphics", enable ? "false" : "true");
	/*if(CreateProcess(L"rset.exe",
		enable ? L"ui.userSettings.hideGraphics false" : L"ui.userSettings.hideGraphics true", NULL, NULL, FALSE, 0,
			NULL, NULL, NULL, &pi) == 0)
		printf("Cannot disable UI for displaying hack window.\n");
	else
	{
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}
	Sleep(500);
	  // Open the existing file.
	HMODULE hModule = GetModuleHandleW(NULL);
	WCHAR path[MAX_PATH];
	GetModuleFileNameW(hModule, path, MAX_PATH);
	MessageBox(NULL, path, L"Result", MB_OK);
*/
	/*hFile = CreateFile (TEXT("rlsTemp.txt"),      // Open One.txt
						GENERIC_READ,           // Open for reading
						0,                      // Do not share
						NULL,                   // No security
						OPEN_EXISTING,          // Existing file only
						FILE_ATTRIBUTE_NORMAL,  // Normal file
						NULL);                  // No template file

	if (hFile == INVALID_HANDLE_VALUE)
	{
		printf ("Could not open rlsTemp.txt");
		return false;
	}

	ReadFile (hFile, buff, 4096, &dwBytesRead, NULL);

	wchar_t szBuff[4096];
	mbstowcs( szBuff, buff, strlen(buff)+1);
	
	if(szBuff == L"true")
		return true;
	
	return false;*/
}

               
void SetIni(const char * key, const char * value)
{
	ini.SetValue("hackOptions", key, value);
	ini.SaveFile(INIPATH);
}


void SetCheckbox(UINT boxid, bool checked)
{
	CheckDlgButton(g_hwndMain, boxid, checked ? BST_CHECKED : BST_UNCHECKED);
}


void GetSettings()
{
	const char * pVal = "no";
#ifdef T440bx
	pVal = ini.GetValue("hackOptions", "flir_logo", "true");
	SetRegistry("ui.userSettings.overlayLogo", pVal);
	SetCheckbox(DisplayLogoID, strstr (pVal, "true"));
#endif

	pVal = ini.GetValue("hackOptions", "disable_nuc", "false");
	SetRegistry("tcomp.services.autoNuc.active", strstr (pVal, "true") ? "false" : "true");
	SetCheckbox(NoAutoNUCID, strstr (pVal, "true"));


	pVal = ini.GetValue("hackOptions", "max_jpeg_quality", "true");
	if(strstr (pVal, "true"))
		SetRegistry("image.services.store.quality", "100");
	SetCheckbox(JPEGqualityID, strstr (pVal, "true"));


	pVal = ini.GetValue("hackOptions", "record_sequence", "false");
	MakeSuperres = strstr (pVal, "true");
	SetCheckbox(SuperresID, strstr (pVal, "true"));

	pVal = ini.GetValue("hackOptions", "record_stack", "false");
	MakeStack = strstr (pVal, "true");
	SetCheckbox(FocusStackID, strstr (pVal, "true"));

	pVal = ini.GetValue("hackOptions", "save_path", "\\StorageCard\\ImageSequences\\");
	strcpy(StoragePath, pVal);

	pVal = ini.GetValue("buttonDefinitions", "joybutton", "13");
	JoyButton = atoi(pVal);

	pVal = ini.GetValue("buttonDefinitions", "backbutton", "112");
	BackButton = atoi(pVal);

	pVal = ini.GetValue("buttonDefinitions", "joyup", "38");
	JoyUp = atoi(pVal);

	pVal = ini.GetValue("buttonDefinitions", "joydown", "40");
	JoyDown = atoi(pVal);

	pVal = ini.GetValue("buttonDefinitions", "joyleft", "37");
	JoyLeft = atoi(pVal);
	
	pVal = ini.GetValue("buttonDefinitions", "joyright", "39");
	JoyRight = atoi(pVal);

	pVal = ini.GetValue("buttonDefinitions", "powerbutton", "119");
	PowerButton = atoi(pVal);

	pVal = ini.GetValue("hackOptions", "programmable_msx", "true");
	SelectedMSX = strstr (pVal, "true");
	SelectedZoom = strstr (pVal, "false");
	SetCheckbox(MSXbuttonID, strstr (pVal, "true"));
	SetCheckbox(ZoomButtonID, strstr (pVal, "false"));

	pVal = ini.GetValue("hackOptions", "programmable_zoom", "false");
	SelectedMSX = strstr (pVal, "false");
	SelectedZoom = strstr (pVal, "true");
	SetCheckbox(MSXbuttonID, strstr (pVal, "false"));
	SetCheckbox(ZoomButtonID, strstr (pVal, "true"));
	//printf("res: %s\n\n", strstr (pVal, "true") ? "true" : "false");
	/*wchar_t szBuff[4096];
	mbstowcs( szBuff, buff, strlen(buff)+1);
	*/
}

void CALLBACK MessageBoxTimer(HWND hwnd, 
                              UINT uiMsg, 
                              UINT idEvent, 
                              DWORD dwTime)
{
   g_bTimedOut = TRUE;
   if (g_hwndTimedOwner)
      EnableWindow(g_hwndTimedOwner, TRUE);
   PostQuitMessage(0);
}


int TimedMessageBox(HWND hwndOwner,
                    LPCTSTR pszMessage,
                    LPCTSTR pszTitle,
                    UINT flags,
                    DWORD dwTimeout)
{
   UINT idTimer;
   int iResult;

   g_hwndTimedOwner = NULL;
   g_bTimedOut = FALSE;

   if (hwndOwner && IsWindowEnabled(hwndOwner))
      g_hwndTimedOwner = hwndOwner;

   //
   // Set a timer to dismiss the message box.
   idTimer = SetTimer(NULL, 0, dwTimeout, (TIMERPROC)MessageBoxTimer);

   iResult = MessageBox(hwndOwner, pszMessage, pszTitle, flags);

   //
   // Finished with the timer.
   KillTimer(NULL, idTimer);

   //
   // See if there is a WM_QUIT message in the queue if we timed out.
   // Eat the message so we do not quit the whole application.
   if (g_bTimedOut)
   {
      MSG msg;
      PeekMessage(&msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE);
      iResult = -1;
   }

   return iResult;
}




LRESULT CALLBACK WndProc (HWND hwnd, UINT umsg, WPARAM wParam, 
                          LPARAM lParam)
{
	static HBRUSH hBrush = CreateSolidBrush(RGB(230,230,230));

  switch (umsg)
  {
    // Add cases such as WM_CREATE, WM_COMMAND, WM_PAINT if you don't 
    // want to pass these messages along for default processing.
	/*case 28:
      printf("NCActivate!\n");
      break;*/


	case WM_PAINT:
        

        //Render(); // Render screen
		break;

	case WM_CTLCOLORSTATIC:
		if(LOWORD(wParam) == DisplayLogoID || LOWORD(wParam) == 6969) 
		{
			HDC hdcStatic = (HDC) wParam;
			SetTextColor(hdcStatic, RGB(0,0,0));
			SetBkColor(hdcStatic, RGB(230,230,230));
			SetBkMode(hdcStatic, TRANSPARENT);
			return (INT_PTR)hBrush;
		}

	case WM_COMMAND:
		/*wNotifyCode = HIWORD(wParam); // notification code
		wID = LOWORD(wParam); // item, control, or accelerator identifier
		hwndCtl = (HWND) lParam; // handle of control*/

		if(HIWORD(wParam) == BN_CLICKED)
		{
			bool checked;
			LRESULT chkState = SendMessage((HWND)lParam, BM_GETCHECK, 0, 0);
                if (chkState == BST_CHECKED)
					{chkState = BST_UNCHECKED; checked = false;}
				else
					{chkState = BST_CHECKED; checked = true;}

			switch (LOWORD(wParam))
			{
				case DisplayLogoID:
					SetIni("flir_logo", checked ? "true" : "false");
					SetCheckbox(DisplayLogoID, checked);
					SetRegistry("ui.userSettings.overlayLogo", checked ? "true" : "false");
					break;

				case NoAutoNUCID:
					SetIni("disable_nuc", checked ? "true" : "false");
					SetCheckbox(NoAutoNUCID, checked);
					SetRegistry("tcomp.services.autoNuc.active", checked ? "false" : "true");
					break;

				case SuperresID:
					SetIni("record_sequence", checked ? "true" : "false");
					SetCheckbox(SuperresID, checked);
					MakeSuperres = checked;
					break;

				case FocusStackID:
					SetIni("record_stack", checked ? "true" : "false");
					SetCheckbox(FocusStackID, checked);
					MakeStack = checked;
					break;

				case JPEGqualityID:
					SetIni("max_jpeg_quality", checked ? "true" : "false");
					SetCheckbox(JPEGqualityID, checked);
					if(checked)
						SetRegistry("image.services.store.quality", "100");
					break;
				
				case MSXbuttonID:
					SetIni("programmable_zoom", "false"); // set others to false!!!
					SetIni("programmable_msx", "true");
					SetCheckbox(ZoomButtonID, false);
					SelectedZoom = false;
					SetCheckbox(MSXbuttonID, true);
					SelectedMSX = true;
						//disable everything else
					break;

				case ZoomButtonID:
					SetIni("programmable_zoom", "true"); // set others to false!!!
					SetIni("programmable_msx", "false");
					SetCheckbox(ZoomButtonID, true);
					SelectedZoom = true;
					SetCheckbox(MSXbuttonID, false);
					SelectedMSX = false;
						//disable everything else
					break;

				case AboutButtonID:
					#ifdef E4
					TimedMessageBox(NULL, 
								L"Spirit's Hack Menu\nFor Ex-series cameras\nv1.0\n\nhttps://spirit.re/projects/flir_hack.php\n\nspirit@spirit.re\n\nIf you paid for this, you were ripped off. It's free.",
								L"Information", 
								MB_OK,
								// NULL first parameter is important.
								6000); 
					#endif
					#if defined(T440bx) || defined(E40)
					TimedMessageBox(NULL, 
								L"Spirit's Hack Menu\nFor Txxx and Exx-series cameras\nv1.0\n\nhttps://spirit.re/projects/flir_hack.php\n\nspirit@spirit.re\n\nIf you paid for this, you were ripped off. It's free.",
								L"Information", 
								MB_OK,
								// NULL first parameter is important.
								10000); 
					#endif
					break;

			}
		}
		return 0;

	case WM_SIZE:
		if(wParam == SIZE_MINIMIZED)
		{
			SetWindowPos(g_hwndMain, NULL, 0, 0, 0, 0, SWP_NOZORDER);
			SetDisplay(true);
			InWindow = false;
			SetForegroundWindow(hwin);
		}
	case WM_MOVE:
		SetWindowPos(g_hwndMain, NULL, 0, 0, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
		return 0;

    case WM_CLOSE:
		SetWindowPos(g_hwndMain, NULL, 0, 0, 0, 0, SWP_NOZORDER);
		SetDisplay(true);
		InWindow = false;
		SetForegroundWindow(hwin);
		ini.SaveFile(INIPATH);
		return 0;

    case WM_DESTROY:
		ini.SaveFile(INIPATH);
		SetForegroundWindow(hwin);
		//m_ceDraw.Release();
		PostQuitMessage(0);
		return 0;

	//default:
		//printf("E:%i ", umsg);
  }

  return DefWindowProc (hwnd, umsg, wParam, lParam);
}



LPTHREAD_START_ROUTINE focusThreadFunc()
{
	while(true)
	{
		//printf("Active window: %i\n", GetForegroundWindow());
		SetForegroundWindow(g_hwndMain);

		Sleep(1000);
	}
    //MessageBox(NULL, _T("thread 1"), _T("thread 1"), MB_OK);
    return 0;
}


LRESULT CALLBACK LLKeyboardHookCallbackFunction( int nCode, 
                              WPARAM wParam, LPARAM lParam ) 
{
	//printf("Keyboard event! %i\n", ((KBDLLHOOKSTRUCT*)lParam)->vkCode); 

	if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyButton) // joy button
	{
		if(wParam == WM_KEYDOWN)
		{	
#ifdef T440bx
			dwOldTime = GetTickCount();
#endif
			if(InWindow)
				SendMessage(NextControl, BM_CLICK, 0, 0);

		}
		#ifdef T440bx
		if(wParam == WM_KEYUP)
		{	
			DWORD tickcount = GetTickCount();
			DWORD dwTimeElapsed = tickcount - dwOldTime;
			if(dwTimeElapsed >= 500)
			{
				printf("Opening hack menu\n");
				SetDisplay(false);
				Sleep(1000);
				SetWindowPos(g_hwndMain, HWND_TOP, 0, 0, 320, 240, NULL);
				SetForegroundWindow(g_hwndMain);
				GetSettings();
				InWindow = true;
			}
		}
		#endif
	}
#if defined(E4) || defined(E40)
	if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyDown && (GetAsyncKeyState(BackButton) || InWindow)) // joy down
	{
		if(wParam == WM_KEYUP && !InWindow)
		{	
				printf("Opening hack menu\n");
				SetDisplay(false);
				Sleep(1000);
				SetWindowPos(g_hwndMain, HWND_TOP, 0, 0, 320, 240, NULL);
				SetForegroundWindow(g_hwndMain);
				GetSettings();
				InWindow = true;
		}
		if(InWindow)
		{
			NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, false);
			if(NextControl == g_hwndLeftRightLabel)
				NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, false); // ignore label

			SetFocus(NextControl);
		}
	}
#endif

	if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == BackButton && InWindow) // menu button
	{
		if(wParam == WM_KEYDOWN	)
		{	
			printf("Closing hack menu\n");
			SendMessage(g_hwndMain, WM_CLOSE, 0, 0);
			SetForegroundWindow(hwin);
		}
	}
#ifdef T440bx
    if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyDown && wParam == WM_KEYUP && (GetAsyncKeyState(BackButton) || InWindow)) // 38 joy down
    {
		if(InWindow)
		{
			NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, false);
			if(NextControl == g_hwndLeftRightLabel || NextControl == g_hwndHackURL)
				NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, false); // ignore label

			SetFocus(NextControl);
		}else if(MakeStack)
		{
			printf("Taking focus stack sequence\n");
			GetLocalTime(&st);
			char filename[128];
			sprintf(filename,"%sfs_%.4d-%.2d-%.2d_%.2d-%.2d-%.2d.seq",StoragePath,st.wYear,st.wMonth,st.wDay, st.wHour, st.wMinute, st.wSecond);
			//sprintf(filename, "%s.seq")
			//printf(filename);
			SetRegistry(".system.buzzer.time", "25");
			SetRegistry(".system.buzzer.state", "time");
			Sleep(10);
			SetRegistry(".image.services.rtrecord.filename", filename);
			Sleep(10);
			SetRegistry(".image.services.rtrecord.count", "80");
			Sleep(10);
			SetRegistry(".image.services.rtrecord.frequency", "30");
			Sleep(10);
			SetRegistry(".system.focus.position", "65535");
			Sleep(500);
			SetRegistry(".image.services.rtrecord.active", "true");
			Sleep(500);
			SetRegistry(".system.focus.speed", "-1");
			Sleep(2000);
			SetRegistry(".image.services.rtrecord.store", "true");
			Sleep(10);
			SetRegistry(".system.buzzer.state", "time");
		}
    }
#endif
	if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyUp && wParam == WM_KEYUP) // 38 joy up
    {
		if(InWindow)
		{
			NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, true);
			if(NextControl == g_hwndLeftRightLabel || NextControl == g_hwndHackURL)
				NextControl = GetNextDlgGroupItem (g_hwndMain, NextControl, true); // ignore labels

			SetFocus(NextControl);
		}else if(MakeSuperres && GetAsyncKeyState(BackButton))
		{
			printf("Taking SR sequence\n");

			GetLocalTime(&st);
			char filename[128];
			sprintf(filename,"%ssr_%.4d-%.2d-%.2d_%.2d-%.2d-%.2d.seq",StoragePath,st.wYear,st.wMonth,st.wDay, st.wHour, st.wMinute, st.wSecond);
			//sprintf(filename, "%s.seq")
			//printf(filename);
#if defined(T440bx) || defined(E40)
			SetRegistry(".system.buzzer.time", "25");
			SetRegistry(".system.buzzer.state", "time");
#endif
			Sleep(10);
			SetRegistry(".image.services.rtrecord.filename", filename);
			Sleep(10);
			SetRegistry(".image.services.rtrecord.count", "16");
			Sleep(10);
#ifdef E4
			SetRegistry(".image.services.rtrecord.frequency", "9");
#else
			SetRegistry(".image.services.rtrecord.frequency", "30");
#endif
			Sleep(10);
			SetRegistry(".image.services.rtrecord.active", "true");
#ifdef E4
			Sleep(7000);
#else
			Sleep(1000);
#endif
			SetRegistry(".image.services.rtrecord.store", "true");
			Sleep(10);
			SetRegistry(".system.buzzer.state", "time");
		}
    }
	if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyLeft && wParam == WM_KEYUP) // 37 joy left
    {
		if(!InWindow && SelectedMSX && GetAsyncKeyState(BackButton))
		{	
			if(MSXLevel >=0.1)
				MSXLevel -= 0.1f;
			sprintf(zoomset,"%f.1",MSXLevel);
#ifdef E4
			SetRegistry(".image.fusion.userDistance", zoomset);
#else
			SetRegistry(".image.fusion.zoomFactor", zoomset);
#endif
			Sleep(50);
		}else if(!InWindow && SelectedZoom && GetAsyncKeyState(BackButton))
		{
			if(ZoomLevel >1)
				ZoomLevel -= 1;

			sprintf(zoomset,"%f.2",ZoomLevel);
			SetRegistry(".image.zoom.zoomFactor", zoomset);
			Sleep(50);
		}else if(InWindow)
		{
			SetFocus(g_hwndMSX);
		}
    }
    if(((KBDLLHOOKSTRUCT*)lParam)->vkCode == JoyRight && wParam == WM_KEYUP) // 39 joy right
    {
		if(!InWindow && SelectedMSX && GetAsyncKeyState(BackButton))
		{
			if(MSXLevel <=50)
				MSXLevel += 0.1f;

			sprintf(zoomset,"%f.1",MSXLevel);
#ifdef E4
			SetRegistry(".image.fusion.userDistance", zoomset);
#else
			SetRegistry(".image.fusion.zoomFactor", zoomset);
#endif
			Sleep(50);
		}else if(!InWindow && SelectedZoom && GetAsyncKeyState(BackButton))
		{
			if(ZoomLevel < 6)
				ZoomLevel += 1;

			sprintf(zoomset,"%f.2",ZoomLevel);
			SetRegistry(".image.zoom.zoomFactor", zoomset);
			Sleep(50);
		}else if(InWindow)
		{
			SetFocus(g_hwndMSX);
		}
    }
    //let default processing take place
    return 0;//CallNextHookEx(g_hInstalledLLKBDhook, nCode, wParam, lParam);
}


BOOL InitInstance (HINSTANCE hInstance, int iCmdShow)
{

  g_hInst = hInstance;
  
  g_hwndMain = CreateWindow (
                  g_szClassName,  // Registered class name         
                  g_szTitle,      // Application window name
                  WS_OVERLAPPED | WS_EX_TOPMOST | WS_SYSMENU,  // Window style
                  CW_USEDEFAULT,  // Horizontal position of the window
                  CW_USEDEFAULT,  // Vertical position of the window
                  CW_USEDEFAULT,  // Window width
                  CW_USEDEFAULT,  // Window height
                  NULL,           // Handle to the parent window
                  NULL,           // Handle to the menu the identifier
                  hInstance,      // Handle to the application instance
                  NULL);          // Pointer to the window-creation data

  // If it failed to create the window, return FALSE.
  if (!g_hwndMain)
    return FALSE;

  //m_ceDraw.Create( g_hwndMain );

  ShowWindow (g_hwndMain, iCmdShow);
  UpdateWindow (g_hwndMain);


	int height = 10;
// Specify the window style for the edit control.
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | 
					WS_BORDER | ES_LEFT | ES_MULTILINE | ES_NOHIDESEL | 
					ES_AUTOHSCROLL | ES_AUTOVSCROLL;  
#ifdef T440bx
	// Create the window for the edit control window.
	g_hwndDisplayLogo = CreateWindow( 
					L"button", 
					L"Display FLIR logo", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					10, 
					height, 
					120,
					20,
					g_hwndMain,
					(HMENU) DisplayLogoID, // 0x8803
					hInstance,
					NULL );
	height+= 20;
#endif
	g_hwndNoAutoNUC = CreateWindow( 
					L"button", 
					L"Disable auto NUC", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					10, 
					height, 
					120,
					20,
					g_hwndMain,
					(HMENU) NoAutoNUCID, // 0x8803
					hInstance,
					NULL );
	height+= 20;

	g_hwndSetJPEGquality = CreateWindow( 
					L"button", 
					L"Force 100% JPEG quality", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					10, 
					height, 
					160,
					20,
					g_hwndMain,
					(HMENU) JPEGqualityID, // 0x8803
					hInstance,
					NULL );
	height+= 20;

	g_hwndMakeSupreres = CreateWindow( 
					L"button", 
					L"Capture superres seq(UP)", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					10, 
					height, 
					160,
					20,
					g_hwndMain,
					(HMENU) SuperresID, // 0x8803
					hInstance,
					NULL );
	height+= 20;
	#ifdef T440bx
	g_hwndCaptureStack = CreateWindow( 
					L"button", 
					L"Capture focus stack(DOWN)", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					10, 
					height, 
					175,
					20,
					g_hwndMain,
					(HMENU) FocusStackID, // 0x8803
					hInstance,
					NULL );
	height+= 20;
	#endif
	g_hwndAboutButton = CreateWindow( 
					L"button", 
					L"About", 
					WS_CHILD | WS_VISIBLE | WS_TABSTOP, 
					260, 
					196, 
					60,
					20,
					g_hwndMain,
					(HMENU) AboutButtonID, // 0x8803
					hInstance,
					NULL );
	g_hwndLeftRightLabel = CreateWindow( 
					L"static", 
					L"Programmable input", 
					WS_CHILD | WS_VISIBLE, 
					200, 
					0, 
					120,
					20,
					g_hwndMain,
					(HMENU) 6969, // 0x8803
					hInstance,
					NULL );
	height = 20;

	g_hwndMSX = CreateWindow( 
					L"button", 
					L"MSX alignment", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					200, 
					height, 
					120,
					20,
					g_hwndMain,
					(HMENU) MSXbuttonID, // 0x8803
					hInstance,
					NULL );
	height += 20;

	g_hwndZoom = CreateWindow( 
					L"button", 
					L"Zoom level", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_TABSTOP, 
					200, 
					height, 
					120,
					20,
					g_hwndMain,
					(HMENU) ZoomButtonID, // 0x8803
					hInstance,
					NULL );


	g_hwndHackURL = CreateWindow( 
					L"button", 
					L"https://spirit.re/projects/flir_hack.php", 
					WS_CHILD | WS_VISIBLE | BS_CHECKBOX, 
					-15, 
					196, 
					250,
					20,
					g_hwndMain,
					(HMENU) 9969, // 0x8803
					hInstance,
					NULL );
  return TRUE;
}


BOOL InitApplication (HINSTANCE hInstance)
{
  WNDCLASS wndclass;

  wndclass.style = CS_HREDRAW | CS_VREDRAW;
  wndclass.lpfnWndProc = (WNDPROC)WndProc;
  wndclass.cbClsExtra = 0;
  wndclass.cbWndExtra = 0;
  wndclass.hIcon = NULL;
  wndclass.hInstance = hInstance;
  wndclass.hCursor = NULL;
  wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
  wndclass.lpszMenuName = NULL;
  wndclass.lpszClassName = g_szClassName;
  
  return RegisterClass (&wndclass);
}

bool ConstCharToBool(const char * pVal)
{
	if(pVal == "true")
		return true;
	return false;
}


int WINAPI WinMain (
               HINSTANCE hInstance,     // Handle to the current instance
               HINSTANCE hPrevInstance, // Handle to the previous instance
               LPWSTR lpCmdLine,        // Pointer to the command line
               int iCmdShow)            // Shows the state of the window
{
    MSG msg;                             // Message structure
	
	ini.SetUnicode(false);
	ini.SetMultiLine(true);
	ini.LoadFile(INIPATH);

	printf("Spirit's FLIR camera hack\nBuilt on %s @ %s\n", __DATE__, __TIME__);
	if (FindWindow(g_szClassName, g_szTitle)){
		SetForegroundWindow(FindWindow(g_szClassName, g_szTitle));
		return FALSE;
	}
  

	if (!hPrevInstance)
	{
		if (!InitApplication (hInstance))
			return FALSE; 
	}



	POINT ptA;
	ptA.x = 15;
	ptA.y = 15;
	
	
	hwin = WindowFromPoint(ptA);

	GetClassName(hwin, strClass, 99);
	printf("Window class: %ls\n", strClass);


	// This is thanks to Grgori Macrio Harbs(Mysoft) in #winapi on Freenode.

	//hwin = FindWindow(L"AHI_WindowClass", L"gui");
		
	GetWindowText(hwin, strWintext, 99);
	printf("Window text: %ls\n", strWintext);

	DWORD pid = NULL;
	DWORD tid = NULL;
	tid = GetWindowThreadProcessId(hwin, &pid);
	//SuspendThread((HANDLE)tid);
	//ResumeThread((HANDLE)tid);
	printf("TID: %02x\n", tid);

	

	if (!InitInstance (hInstance, iCmdShow))
		return FALSE;

	SetWindowPos(g_hwndMain, NULL, 0, 0, 0, 0, SWP_NOZORDER);
	//ShowWindow(g_hwndMain, SW_HIDE);

	GetSettings();

	NextControl = GetNextDlgTabItem(g_hwndMain, g_hwndDisplayLogo, false);
	
	SetForegroundWindow(hwin);

	if(!ActivateKBHook(hInstance, LLKeyboardHookCallbackFunction))
	{
		printf("Couldn't install keyboard hook.\n");
		exit(1);
	}
	
	//WinEventProcCallback, 0, 0, WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNPROCESS);
	//hFocusThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)&focusThreadFunc, NULL, 0, NULL);

	while (GetMessage (&msg, NULL, 0, 0))
	{
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}

	return msg.wParam;
}