#include <windows.h>
#include "winceKBhook.h"

HWINEVENTHOOK hEvent = NULL;

LRESULT CALLBACK LLKeyboardHookCallbackFunction( int nCode, 
                              WPARAM wParam, LPARAM lParam ) 
{
	printf("[Keyboard event] Param: %i%s| vkCode: %i\n", wParam, wParam == WM_KEYDOWN ? "(WM_KEYDOWN) " : wParam == WM_KEYUP ? "(WM_KEYUP)   ": "Unknown ", ((KBDLLHOOKSTRUCT*)lParam)->vkCode);
    //let default processing take place
    return 0;//CallNextHookEx(g_hInstalledLLKBDhook, nCode, wParam, lParam);
}

int WINAPI WinMain (
               HINSTANCE hInstance,     // Handle to the current instance
               HINSTANCE hPrevInstance, // Handle to the previous instance
               LPWSTR lpCmdLine,        // Pointer to the command line
               int iCmdShow)            // Shows the state of the window
{
    MSG msg;                             // Message structure

	printf("Spirit's Windows CE Key Mapper - v1.0\nBuilt using the Windows Mobile 5.0 Pocket PC SDK for ARMV4I\nhttps://spirit.re/projects/wince_key_mapper.php\n");
	printf("Build date: %s @ %s\n", __DATE__, __TIME__);

	if(!ActivateKBHook(hInstance, LLKeyboardHookCallbackFunction))
	{
		printf("Couldn't set keyboard hook.\n");
		exit(1);
	}
	
	printf("Keyboard hook set, press buttons to log.\n");

	while (GetMessage (&msg, NULL, 0, 0))
	{
			TranslateMessage (&msg);
			DispatchMessage (&msg);
	}

	return msg.wParam;
}