/* ---------------------------------------------------------------------------------------------------
 *  
 *                          Windows CE Graphics Libary v1.00.0000
 *  
 *        
 *    Written by James.
 *    Bug report : jiet@msn.com
 *                                                             Copyright 2001
 */
// File: CEGDefine.h
// Macro Code define.
//-----------------------------------------------------------------------------------------------------
//										Update Information.
//-----------------------------------------------------------------------------------------------------

/*
 * Created by James D. 2001.
 * Date: 01/11/2001
 */

#ifndef _CEGDEFINE_
#define _CEGDEFINE_

//#define GDI_ENUM
#ifndef GDI_ENUM
	#include "Gx.h"
#else
	#include "GAPI_Emu.h"
#endif

// DLL Export...
#ifdef CEGL_EXPORTS
#define CEGL_API __declspec(dllexport)
#else
#define CEGL_API __declspec(dllimport)
#endif

// Define Error Code here...
// Error Code Must be Start From 100 or equal 0
#define CEG_ERROR_UNKNOWN                   0
/* CEGGraphics Error Code...                 */
#define CEG_GRAPH_OPENDISP_FAILED           100
#define CEG_GRAPH_OPENINPUT_FAILED          101
#define CEG_GRAPH_MEMALLOC_FAILED           102
#define CEG_GRAPH_CLOSEINPUT_FAILED         103
#define CEG_GRAPH_CLOSEDISP_FAILED          104
#define CEG_GRAPH_SUSPENDED                 105
#define CEG_GRAPH_BEGINDRAW_FAILED          106
#define CEG_GRAPH_DISPMEM_NULL              107
#define CEG_GRAPH_ENDDRAW_FAILED            108
#define CEG_GRAPH_SUSPEND_FAILED            109
#define CEG_GRAPH_RESUME_FAILED             110
#define CEG_GRAPH_ERROR                     111
#define CEG_GRAPH_VB_NULL				    112
/* End CEGGraphics                           */

/* CEGDraw Error Code...                     */
#define CEG_DRAW_OBJECT_NULL                113
#define CEG_DRAW_PEN_NULL                   114
#define CEG_DRAW_FONTFILE_NULL              115
/* End CEGDraw                               */

/* Draw Mode define...                       */
#define CEG_DRAWMODE_DOUBLEBUFFER 0               // Default mode, double buffer
#define CEG_DRAWMODE_DIRECTDRAW   1               // Direct draw mode
/* End DrawMode define                       */

/* GDI Object type define...                 */
#define CEG_GDIOBJECT_TYPE_PEN   10000
#define CEG_GDIOBJECT_TYPE_BRUSH 10001
#define CEG_GDIOBJECT_TYPE_FONT  10002
/* End GDI Object                            */

/* CE float Point Struct define          */
typedef struct tagFLOATPOINT
{
	float x;
	float y;
}FLOATPOINT;

/* End float point define                    */

#endif // _CEGDEFINE_